require "tx_core"


module Tx
    
    class Index
        
        def initialize(*args)
          @unsafe= UnsafeIndex.new(*args)
        end
        
        def inspect()
          return "\#<%p:0x%x>" % [self.class, self.object_id]
        end
        
        [:longest_prefix, :include, :search_prefixes, :search_expansions].each() do |name|
          define_method(name) do |*args|
            (str, pos, len, *opt)= args
            raise(ArgumentError, "argument pos is negative") if pos && pos < 0
            pos||= 0
            pos= str.length if pos > str.length
            len= str.length - pos if !len || len < 0 || len > str.length - pos
            @unsafe.__send__(name, str, pos, len, *opt)
          end
        end
        
    end
    
end
